\begindata{text,752768}
\textdsversion{12}
\template{default}
\bold{\center{\italic{

THE ANDREW INFORMATION FINDER}}}



\center{What is Andrew?

Software Components

Andrew Ready Platforms

Remote Andrew Demo Service

The Source Code and Binary Distributions

Join the Andrew Consortium

Services and Offerings from the Consortium

"Andrew in Print"

"Andrew on Tape"

Contact Information}

\center{\subsection{\center{
Andrew Is...}}

}
\indent{\indent{Compound document architecture...Word processor...Drawing 
editor...Mail / bulletin board reader, writer, manager...Spreadsheet / 
table editor...Widget set...Application builder...Scriptable...In C and 
C++...For X11

}}
...With a consistent, integrated user interface so you can create compound 
documents containing pictures, words, tables, graphs and more.



The \italic{Andrew User Interface System (Andrew)} is a word processor for 
compound documents, a collection of related applications, and an 
environment for building new applications and embeddable objects. Andrew 
runs under X11 and provides a dynamically-loadable object-oriented 
environment wherein objects can be embedded in one-another. Thus documents 
can contain not only multiple fonts and other typography, but also embedded 
raster images, spreadsheets, drawings, equations, simple animations, and so 
on.  These embedded objects may themselves contain other objects, including 
text. The release includes many objects, including those mentioned above, 
along with a help browser, a directory browser, a font editor, a system 
monitoring tool, an editor-based shell interface, and source-text editors 
for C, C++, Lisp, HTML, Pascal, and other languages.


The underlying\italic{ Andrew Toolkit architecture (ATK)} supports 
cooperation between objects not only for screen display, but also for file 
storage, cut/paste across windows, an application construction environment, 
an extension language, and printing.  There is full support for programmers 
to create new objects and new applications.


The\italic{ Andrew Message System (AMS)}, a component of Andrew, provides a 
multi-media interface to mail and bulletin-boards.  AMS contains many 
advanced  features including authentication, return receipts, automatic 
sorting of mail, vote collection and tabulation, enclosures, audit trails 
of related messages, and subscription management. It also provides a 
variety of interfaces that support character-based terminals and 
low-function personal computers in addition to high-function workstations. \



\bold{Components of the Andrew System}


The following components are available in Andrew 6.3 and later versions. 
 Some respond to frequently requested applications in X, such as: \



	word processor --> ez

	drawing editor --> figure

	mail and news reader --> messages

	font editor --> bdffont

	documentation browser --> help

	directory browser --> bush


\italic{ Andrew applications (graphic and interactive)}


bush - directory browser

chump - schedule maintainer

console - shell interface / terminal replacement

ez - word processor and program editor

bdffont - font editor (for fonts in bdf format)

help - documentation browser  (includes all AUIS help files)

launch - provides a menu of AUIS applications

messages - mail and news reader, manager, and composer

pipescript - viewer useful as stdout

prefed - preferences editor

sendmessage - application for sending a message or news posting

typescript - shell interface (terminal substitute)


\italic{Graphical, interactive editors that are both applications and 
insets}


eq - equation inset

fad - animation editor

figure - drawing editor

layout - inset for arbitrary layout of enclosed insets

lset - display two adjacent insets

ness - extension and string processing language

org - display and edit hierarchies

page - allow flipping between pages

raster - editor for monochrome bitmapped images

table - table / spreadsheet inset

text - text, document, and program editor (the heart of ez and other

applications)


\italic{Commonly used non-interactive Andrew applications}


datacat - concatenate ATK files

ezprint - print an ATK document

nessrun - runs a Ness script (the extension and string processing language)

preview - preview an ATK document on screen


\italic{ File format converters}


from ATK to: RTF, ASCII, PostScript, troff

to ATK from: ppm, Scribe, RTF, troff, X window dump

convertraster - various raster formats


\italic{Embeddable insets not usually used as applications}


clock - analog clock

eq - equations

header - specify document headers and footers

image - display images from many formats: jpeg, gif, tiff, ...

link - hypertext-like link

month - display calendar for a month

note - annotation

text - the text object itself

timeoday - digital clock

writestamp - time file was written


\italic{Editing tools}


compchar - keyboard input of characters for European languages

compile - support compilation and error review

complete - filename completion for typescript

dired - directory browser

dsearch - dynamic search

ezdiff - compare two ASCII files

filter - process a region of a document through a shell command

isearch - incremental search

lookz - style table editor

spell - spelling correction (uses ispell)


\italic{Source text editing tools for:}


assembler, C++, C, Lisp, man pages, Modula, Modula-3, Pascal


\italic{Tools for constructing insets and applications}


arb - ADEW application builder interface

bison - GNU parser generator (enhanced)

class - preprocessor for ATK object system header files

createcon - ADEW tool to generate C code for interface

createinset - create a prototypical inset under a new name

doindex - classC postprocessor

genmake - Makefile generator for classC

genstatl - generate statically loadable application

gentlex - lexical analyzer generator

makedo - classC post processor to create objects

runadew - runtime for ADEW application builder

sym - symbol table object

whichdo - find an inset on the CLASSPATH


\italic{Additional insets available for building applications}


button, display text string, entry of labeled text string, four position

switch, multiple buttons, multiple sliders, multiple string entry,

on/off switch, slider, slider controlling array of strings, text list,

thumb knob


\bold{Platforms}


Andrew has been used successfully on (at least) these platforms: \



IBM---RT AOS 3.4, RT AIX 2.2.1, RS/6000 AIX3.1, PS/2 AIX1.2 \


SUN---Sun3 3.5, Sun3 4.0, Sun4 4.0, Sun3 4.1, Sun4 4.1, Sun4Mach, Solaris

DEC---Vax Ultrix 3.1, Vax Ultrix 4.2, Vax BSD, DEC MIPS, Pmax Mach

Other---HP, SCO I386, SGI IRIX 4.0, Apollo, Macintosh II, MacMach, 486 
Mach, Telmat, Linux


\bold{Remote Demo Service}


Try out Andrew from your own work station via the Remote Andrew Demo 
Service. You will need a host machine on the Internet running the X11 
window system. You will be able to compose multimedia documents, navigate 
through the interactive Andrew Tour, and use the Andrew Message System to 
browse through a few of CMU's four thousand bulletin boards and newsgroups.


To get started, simply run the following command on your machine: finger 
@atk.itc.cmu.edu (128.2.203.218). The remote demo system will give you 
further instructions.


\bold{Accessing the Source Code and Binary Distributions}


Due to the number of requests for binary distributions and the growing 
popularity of the Linux binary "package" distribution, the Andrew 
Consortium is now making its latest release available in a similar format 
for a number of platforms.  Binary distribution "packages" are available 
for the four different system components, or for all of these under the 
"full" option:


\bold{	wp} - for those wanting a basic word-processor

	\bold{doc} - for those who are intereted in documentation only

	\bold{src} - for source code developers

	\bold{mail} - for users wanting the MIME-compatible messages interface

	\bold{full} - all of the above plus other goodies


 Binary distributions are now available for the following system types: \



	RS/6000   \


	Sun 4C Sparcstation    \


	HP 720    \


	DEC Pmax

	Linux  (clone of sunsite.unc.edu)


Sources and binaries are available online via anonymous ftp from: 
ftp.andrew.cmu.edu (IP: 128.2.232.154) in pub/AUIS/bin-dist. See the README 
file. Other ftp sites are: ftp.x.org (IP: 192.112.44.100) and its clone 
sites (see pub/R6untarred/contrib/lib/auis-6.3). On the nationwide AFS file 
system, Andrew is available in: /afs/cs.cmu.edu/project/atk-ftp. Source and 
binary tapes are also available by mail (see "Services and Offerings" 
below).


\bold{Become a Member of the Andrew Consortium}



The School of Computer Science at Carnegie Mellon University has 
established the Andrew Consortium to maintain and enhance the Andrew User 
Interface System (Andrew).


The Consortium offers outside organizations the opportunity to help shape 
the future of the system. Participate in the development of Andrew, utilize 
the latest advances by our technical staff, and undertake commercial 
exploitation with the active cooperation of the developers.


The overall efforts of the Consortium staff are directed toward: \


\leftindent{

+ increased quality in existing media,

+ enhancements, including a direct manipulation interface builder,

+ embedding of applications such as generic X applications,

+ increased potential for transition from Andrew to successor systems

+ interoperability with standards such as Posix, Motif, C++, OLE,  and 
SGML.

}

The Consortium makes its most up-to-date release, currently Andrew 7 in 
C++, available only to members.  The current publicly available Andrew 
release is 6.3, released via anonymous file transfer over the internet. \



Membership in the Consortium is offered to organizations interested in 
exploiting Andrew technology within their operations or products.  All 
members support the consortium as it:

\leftindent{

+ Enhances, maintains, and distributes the Andrew software base.

+ Conducts an annual meeting to review progress and set priorities.

+ Distributes a quarterly newsletter

+ Monitors the info-andrew mailing list.

}

We offer memberships at three levels: Full, Contributing and Associate. You 
are cordially invited to join us. Please contact our Director, Fred Hansen 
<wjh@andrew.cmu.edu> if you would like to discuss the opportunities that 
the Consortium has to offer.


\bold{Consortium Services and Offerings}


\smaller{The following materials are provided by the Andrew Consortium at 
Carnegie Mellon University for internal educational use only and may not be 
reproduced for sale or distribution. Please mark your selections below:


\bold{\center{ANDREW IN PRINT}}


    _____  \bold{ The Andrew User Guide}   US$25


This printed and bound guide, offers a comprehensive description of how to 
use Andrew applications and insets.  Chapters cover ez, help, typescript, 
messages, console, raster, figure, table, and many other facets of the 
system. (130 pages)


   _____  \bold{ Selected Technical Papers on Andrew}   US$30


This set represents a selection of some of our most handy references on the 
Andrew system. (250 pages)


	A Guide to Andrew (User Tutorial)

	Ness:  An Extension Language for the Andrew Toolkit

	Programming with the Andrew Toolkit

	ADEW:  The Andrew Development Environment Workbench

	Createinset:  Generate Source Files for a New Inset

	The Andrew Message System		\



   _____   \bold{Andrew Technical Conference Proceedings   }US$20


Each year, the Andrew Consortium sponsors its own technical conference on 
Andrew.  This volume includes the entire proceeedings of the 1994 event, 
(Application Developer's View of Andrew, The Web Browser, Compound Document 
Architectures), as well as highlights from the 1992 and 1993 events. (85 
pages)


   _____  \bold{ Programming Documentation on Andrew   }US$95


This package represents a complete set of programming documentation on the 
Andrew system, sold in hard copy form. (1250 pages)


\bold{\center{ANDREW ON TAPE}}


   _____  \bold{ Public Source Tape (6.3 in C)   }US$150


Want the source code on tape? Here it is, ready to use on your 
Andrew-compatible platform.


    _____  \bold{ Private Source Tape (7.2 in C++)}

	\


	______   US$350 for business use	_____________________  Name of designated 
user

	______   US$250 for personal use	_____________________  Company name


We also offer you the chance to purchase our most up-to-date version of the 
source in C++. Take advantage of the latest programming advances made by 
our technical staff. (This tape must be designated for the use of one 
individual only.)


    _____  \bold{ Binary Distribution Package (6.3 in C)   }US$100 \



This tape provides you with everything you need to get Andrew up and 
running on your RS/6000, Sun 4C Sparcstation, HP 720, DEC Pmax or Linux 
machine. Files include the source code, word processing, documentaton, and 
mail for MIME-compatible messages.


	If you are ordering ANDREW ON TAPE, please specify format:

		_____	1/4" streaming tape (150 MB)

		_____	8 mm DAT tape (2.3 GB)

		_____	8 mm HP Iotamat format

	\


US$	_______	SUBTOTAL

	_______	   Add US$20 per item for US express mail delivery

	_______	   Add US$25 per item for air mail delivery outside the US

	_______	   Add US$40 per item for express mail delivery outside the US

US$	_______	GRAND TOTAL


Name      ___________________________________________________

Company ___________________________________________________

Address   ___________________________________________________

Phone      ______________  Fax ____________  Email _______________


Please place your order by mailing the previous section of this form with 
your selections marked.  Include a check made payable to Carnegie Mellon 
University and send it to the address listed below.


\bold{Contact Information

}
Andrew Consortium				AnnMarie Zanger			\


School of Computer Science			Assistant Director

Carnegie Mellon University

5000 Forbes Avenue				Phone: (412) 268-6710

Pittsburgh, PA 15213-3890			Fax:  (412) 268-5571


Email:	info-andrew-requests@andrew.cmu.edu.		\


Bugs:	info-andrew-bugs@andrew.cmu.edu

News:	info-andrew@cmu.edu

Web:	
http://www.cs.cmu.edu:8001/afs/cs.cmu.edu/project/atk-ftp/web/andrew-home.ht\
ml

Demo:	finger @atk.itc.cmu.edu

Access:	ftp.andrew.cmu.edu:pub/AUIS/bin-dist/README\
}\enddata{text,752768}
